import axios from 'axios';
import { isEmpty, keys, has } from 'lodash';
import { createActions } from 'redux-actions';

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var getWithParamsUrl = function getWithParamsUrl(path, params) {
  var regex = /\[(.*?)\]/g;
  var replacePath;

  if (!isEmpty(params)) {
    path.replace(regex, function (match, name, surname) {
      return console.log(surname + ", " + name);
    });
    replacePath = path.replace(regex, function (match, name, surname) {
      var replaceStr = "" + params[name];
      return replaceStr;
    });
  } else {
    replacePath = path;
  }

  return replacePath;
};

var getApi = function getApi(_ref) {
  var url = _ref.url,
      params = _ref.params,
      config = _ref.config;

  try {
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp4 = _catch(function () {
      function _temp2(_axios$put) {
        function _temp(_axios$put2) {
          _isEmpty ? _axios$put2 : res = _axios$put2;
          response = res.data;
        }

        return _isEmpty ? _temp(res = _axios$put) : Promise.resolve(axios.put(path, config)).then(_temp);
      }

      var _isEmpty = isEmpty(config);

      return _isEmpty ? Promise.resolve(axios.put(path)).then(_temp2) : _temp2(0);
    }, function (err) {
      console.log(err);
    });

    return Promise.resolve(_temp4 && _temp4.then ? _temp4.then(function () {
      return response;
    }) : response);
  } catch (e) {
    return Promise.reject(e);
  }
};

var postApi = function postApi(_ref2) {
  var url = _ref2.url,
      params = _ref2.params,
      body = _ref2.body,
      config = _ref2.config;

  try {
    console.log("postApi");
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp8 = _catch(function () {
      function _temp6(_axios$post) {
        function _temp5(_axios$post2) {
          _isEmpty2 ? _axios$post2 : res = _axios$post2;
          response = res.data;
        }

        return _isEmpty2 ? _temp5(res = _axios$post) : Promise.resolve(axios.post(path, body)).then(_temp5);
      }

      var _isEmpty2 = isEmpty(config);

      return _isEmpty2 ? Promise.resolve(axios.post(path, body, config)).then(_temp6) : _temp6(0);
    }, function (err) {
      console.log(err);
    });

    return Promise.resolve(_temp8 && _temp8.then ? _temp8.then(function () {
      return response;
    }) : response);
  } catch (e) {
    return Promise.reject(e);
  }
};

var putApi = function putApi(_ref3) {
  var url = _ref3.url,
      params = _ref3.params,
      body = _ref3.body,
      config = _ref3.config;

  try {
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp12 = _catch(function () {
      function _temp10(_axios$put3) {
        function _temp9(_axios$put4) {
          _isEmpty3 ? _axios$put4 : res = _axios$put4;
          response = res.data;
        }

        return _isEmpty3 ? _temp9(res = _axios$put3) : Promise.resolve(axios.put(path, body)).then(_temp9);
      }

      var _isEmpty3 = isEmpty(config);

      return _isEmpty3 ? Promise.resolve(axios.put(path, body, config)).then(_temp10) : _temp10(0);
    }, function (err) {
      console.log(err);
    });

    return Promise.resolve(_temp12 && _temp12.then ? _temp12.then(function () {
      return response;
    }) : response);
  } catch (e) {
    return Promise.reject(e);
  }
};

var deleteApi = function deleteApi(_ref4) {
  var url = _ref4.url,
      params = _ref4.params,
      config = _ref4.config;

  try {
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp16 = _catch(function () {
      function _temp14(_axios$delete) {
        function _temp13(_axios$delete2) {
          _isEmpty4 ? _axios$delete2 : res = _axios$delete2;
          response = res.data;
        }

        return _isEmpty4 ? _temp13(res = _axios$delete) : Promise.resolve(axios["delete"](path, config)).then(_temp13);
      }

      var _isEmpty4 = isEmpty(config);

      return _isEmpty4 ? Promise.resolve(axios["delete"](path)).then(_temp14) : _temp14(0);
    }, function (err) {
      console.log(err);
    });

    return Promise.resolve(_temp16 && _temp16.then ? _temp16.then(function () {
      return response;
    }) : response);
  } catch (e) {
    return Promise.reject(e);
  }
};

var fetchApi = function fetchApi(_ref5) {
  var method = _ref5.method,
      url = _ref5.url,
      params = _ref5.params,
      body = _ref5.body,
      config = _ref5.config;

  try {
    var _temp25 = function _temp25() {
      console.log("responseresponse", response);
      return response;
    };

    method = method.toLowerCase();
    console.log({
      method: method,
      url: url,
      params: params,
      body: body,
      config: config
    });
    var error = null;
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp26 = _catch(function () {
      var _temp22 = function () {
        if (method === "get" || method === "delete") {
          var _temp27 = function _temp27(_axios$method) {
            function _temp17(_axios$method2) {
              _isEmpty7 ? _axios$method2 : res = _axios$method2;
              response = res.data;
            }

            return _isEmpty7 ? _temp17(res = _axios$method) : Promise.resolve(axios[method](path, config)).then(_temp17);
          };

          var _isEmpty7 = isEmpty(config);

          return _isEmpty7 ? Promise.resolve(axios[method](path)).then(_temp27) : _temp27(0);
        } else {
          var _temp28 = function () {
            if (method === "post" || method === "put") {
              var _temp29 = function _temp29(_axios$method3) {
                function _temp19(_axios$method4) {
                  _isEmpty8 ? _axios$method4 : res = _axios$method4;
                  response = res.data;
                }

                return _isEmpty8 ? _temp19(res = _axios$method3) : Promise.resolve(axios[method](path, body)).then(_temp19);
              };

              var _isEmpty8 = isEmpty(config);

              return _isEmpty8 ? Promise.resolve(axios[method](path, body, config)).then(_temp29) : _temp29(0);
            } else {
              console.error("Ensure your method please");
            }
          }();

          if (_temp28 && _temp28.then) return _temp28.then(function () {});
        }
      }();

      if (_temp22 && _temp22.then) return _temp22.then(function () {});
    }, function (err) {
      error = err;
      console.log(err);
    });

    return Promise.resolve(_temp26 && _temp26.then ? _temp26.then(_temp25) : _temp25(_temp26));
  } catch (e) {
    return Promise.reject(e);
  }
};

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var prepareActions = function prepareActions(val) {
  var dataActions = [];
  var newVal = val.replace(/[A-Z]/g, function (m) {
    return "_" + m;
  }).toUpperCase();
  dataActions = [].concat(dataActions, ["START_LOADING_" + newVal, "" + newVal, "STOP_LOADING_" + newVal]);
  return createActions.apply(void 0, dataActions);
};
var dispatchActions = function dispatchActions(data) {
  var dataFns = {};
  data === null || data === void 0 ? void 0 : data.map(function (val) {
    var dispatchActions = prepareActions(val === null || val === void 0 ? void 0 : val.name);
    var slice = 3;
    var index = 0;

    var _loop = function _loop() {
      var _extends2;

      var partsKeys = keys(dispatchActions).splice(index, slice);
      dataFns = _extends({}, dataFns, (_extends2 = {}, _extends2[(val === null || val === void 0 ? void 0 : val.name) + "Action"] = function Action(data) {
        if (data === void 0) {
          data = {};
        }

        return function (dispatch) {
          try {
            console.log(data);
            dispatch(dispatchActions[partsKeys[0]](true));
            has(val, "fn") ? dispatch(dispatchActions[partsKeys[1]](val.fn(data))) : dispatch(dispatchActions[partsKeys[1]](data));
            dispatch(dispatchActions[partsKeys[2]](false));
            return Promise.resolve();
          } catch (e) {
            return Promise.reject(e);
          }
        };
      }, _extends2));
      index = index + slice;
    };

    while (index < keys(dispatchActions).length) {
      _loop();
    }
  });
  return dataFns;
};
var dispatchActionsWithApi = function dispatchActionsWithApi(data) {
  var dataFns = {};
  data === null || data === void 0 ? void 0 : data.map(function (val) {
    var name = val.name,
        url = val.url,
        method = val.method,
        config = val.config;
    var dispatchActions = prepareActions(name);
    var slice = 3;
    var index = 0;

    var _loop2 = function _loop2() {
      var _extends3;

      var partsKeys = keys(dispatchActions).splice(index, slice);
      dataFns = _extends({}, dataFns, (_extends3 = {}, _extends3[name + "Action"] = function Action(data) {
        return function (dispatch) {
          try {
            var _temp3 = function _temp3(_fetchApi) {
              function _temp(_fetchApi2) {
                _has2 ? _fetchApi2 : res = _fetchApi2;
                has(val, "fn") ? dispatch(dispatchActions[partsKeys[1]](val === null || val === void 0 ? void 0 : val.fn({
                  data: data,
                  res: res
                }))) : dispatch(dispatchActions[partsKeys[1]](res));
                dispatch(dispatchActions[partsKeys[2]](false));
              }

              return _has2 ? _temp(res = _fetchApi) : Promise.resolve(fetchApi({
                method: method,
                url: url,
                body: method == "get" ? "" : data,
                config: config
              })).then(_temp);
            };

            var res;
            dispatch(dispatchActions[partsKeys[0]](true));
            console.log(data);

            var _has2 = has(data, "params");

            return Promise.resolve(_has2 ? Promise.resolve(fetchApi({
              method: method,
              url: url,
              params: data === null || data === void 0 ? void 0 : data.params,
              body: has(data, "body") && method == "get" ? "" : data.body,
              config: config
            })).then(_temp3) : _temp3(0));
          } catch (e) {
            return Promise.reject(e);
          }
        };
      }, _extends3));
      index = index + slice;
    };

    while (index < keys(dispatchActions).length) {
      _loop2();
    }
  });
  return dataFns;
};

var actionsCondition = function actionsCondition(data) {
  var reducerMap = {};
  var initialState = {};
  data.map(function (val) {
    var _extends2, _extends7;

    var key = val.key,
        stateKey = val.stateKey,
        initStateKey = val.initStateKey,
        fn = val.fn;
    var newVal = key.replace(/[A-Z]/g, function (m) {
      return "_" + m;
    }).toUpperCase();
    initialState = _extends({}, initialState, (_extends2 = {}, _extends2[stateKey] = initStateKey, _extends2["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = false, _extends2));
    reducerMap = _extends({}, reducerMap, (_extends7 = {}, _extends7[newVal] = {
      next: function next(state, action) {
        if (has(val, "fn")) {
          var _extends3;

          return _extends({}, state, (_extends3 = {}, _extends3[stateKey] = fn(state, action), _extends3));
        } else {
          var _extends4;

          return _extends({}, state, (_extends4 = {}, _extends4[stateKey] = action === null || action === void 0 ? void 0 : action.payload, _extends4));
        }
      }
    }, _extends7["START_LOADING_" + newVal] = {
      next: function next(state, action) {
        var _extends5;

        return _extends({}, state, (_extends5 = {}, _extends5["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = true, _extends5));
      }
    }, _extends7["STOP_LOADING_" + newVal] = {
      next: function next(state, action) {
        var _extends6;

        return _extends({}, state, (_extends6 = {}, _extends6["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = false, _extends6));
      }
    }, _extends7));
  });
  return {
    reducerMap: reducerMap,
    initialState: initialState
  };
};

var index = {
  test: 'test',
  fetchApi: fetchApi,
  getApi: getApi,
  postApi: postApi,
  putApi: putApi,
  deleteApi: deleteApi,
  dispatchActions: dispatchActions,
  dispatchActionsWithApi: dispatchActionsWithApi,
  actionsCondition: actionsCondition
};

export default index;
//# sourceMappingURL=index.modern.js.map
